%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculates the grid supping inverter A matrix
%
% @author Andrea Angioni <aangioni@eonerc.rwth-aachen.de>
% @copyright 2018, Institute for Automation of Complex Power Systems, EONERC
% @license GNU General Public License (version 3)
%
% Statespacemodeldistribution
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function AINV = def_AINV_supp_PV(DM,x)
AINV =([[-DM.wc(x), 0, 0, 0, 0, 0, 0, 0, 0, 0];...
    [0, -DM.wc(x), 0, 0, 0, 0, 0, 0, 0, 0];...
    [0, -1, 0, 0, 0, 0, 0, 0, 0, 0];...
    [-1, 0, 0, 0, 0, 0, 0, 0, 0, 0];...
    [0, -DM.kpv_d(x), DM.kiv_d(x), 0, 0, 0, -1, 0, 0, 0];...
    [-DM.kpv_q(x), 0, 0, DM.kiv_q(x), 0, 0, 0, -1, 0, 0];...
    [0, -(DM.kpc_d(x)*DM.kpv_d(x))/DM.Lf(x), (DM.kiv_d(x)*DM.kpc_d(x))/DM.Lf(x), 0, DM.kic_d(x)/DM.Lf(x), 0, -(DM.kpc_d(x) + DM.rf(x))/DM.Lf(x), 0, -1/DM.Lf(x), 0];...
    [-(DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x), 0, 0, (DM.kiv_q(x)*DM.kpc_q(x))/DM.Lf(x), 0, DM.kic_q(x)/DM.Lf(x), 0, -(DM.kpc_q(x) + DM.rf(x))/DM.Lf(x), 0, -1/DM.Lf(x)];...
    [0, 0, 0, 0, 0, 0, 1/DM.Cf(x), 0, 0, 2*DM.f*pi];...
    [0, 0, 0, 0, 0, 0, 0, 1/DM.Cf(x), -2*DM.f*pi, 0]]);

if x == DM.ref
    AINV = ([[-DM.wc(x), 0, 0, 0, 0, 0, 0, 0, 0, 0];...
        [0, -DM.wc(x), 0, 0, 0, 0, 0, 0, 0, 0];...
        [0, -1, 0, 0, 0, 0, 0, 0, 0, 0];...
        [-1, 0, 0, 0, 0, 0, 0, 0, 0, 0];...
        [0, -DM.kpv_d(x), DM.kiv_d(x), 0, 0, 0, -1, 0, 0, 0];...
        [-DM.kpv_q(x), 0, 0, DM.kiv_q(x), 0, 0, 0, -1, 0, 0];...
        [0, -(DM.kpc_d(x)*DM.kpv_d(x))/DM.Lf(x), (DM.kiv_d(x)*DM.kpc_d(x))/DM.Lf(x), 0, DM.kic_d(x)/DM.Lf(x), 0, -(DM.kpc_d(x) + DM.rf(x))/DM.Lf(x), 0, -1/DM.Lf(x), 0];...
        [-(DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x), 0, 0, (DM.kiv_q(x)*DM.kpc_q(x))/DM.Lf(x), 0, DM.kic_q(x)/DM.Lf(x), 0, -(DM.kpc_q(x) + DM.rf(x))/DM.Lf(x), 0, -1/DM.Lf(x)];...
        [0, 0, 0, 0, 0, 0, 1/DM.Cf(x), 0, 0, 2*DM.f*pi];...
        [0, 0, 0, 0, 0, 0, 0, 1/DM.Cf(x), -2*DM.f*pi, 0]]);
end %in this way we block the evolution of the angle of the reference inv.
end